// see us after school for copyright and license details

#define _POSIX_C_SOURCE 200809L

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include "marxup.h"

void handler(int signal) {
  if(signal == SIGINT)
    exit(0);
}

void usage(char *name) {
  printf("Usage: %s [-h] [-o outfile] file...\n", name);
}


int main(int argc, char **argv) {
  char *name = argv[0];
  char *out = NULL;
  char *in = NULL;

  int c;
  while((c = getopt(argc, argv, "ho:")) != -1) {
    switch(c) {
      case 'o':
        out = optarg;
        break;
      case 'h':
        usage(name);
        exit(0);
    }
  }
  argc -= optind; argv += optind;

  if(argc < 1)
    usage(name), exit(0);

  signal(SIGINT, handler);

  FILE *out_fp = out ? fopen(out, "w") : stdout;
  if(!out_fp)
    fprintf(stderr, "%s: %s: No such file or directory\n", name, out), exit(1);

  FILE *in_fp;

  for(int i = 0; i < argc; i++) {
    in = argv[i];
    in_fp = !strncmp(in, "-", 1) ? stdin : fopen(in, "r");
    if(!in_fp)
      fprintf(stderr, "%s: %s: No such file or directory\n", name, in), exit(1);
    marxup(in_fp, out_fp, 0);
  }

  return 0;
}

